import mock
import unittest2 as unittest


class TestMiscellaneous(unittest.TestCase):

    def createMiscellaneous(self, context, request):
        from inicie.cropimage.browser.miscellaneous import Miscellaneous
        return Miscellaneous(context, request)

    def test_instance(self):
        context = mock.Mock()
        request = mock.Mock()
        item = self.createMiscellaneous(context, request)
        from inicie.cropimage.browser.miscellaneous import Miscellaneous
        self.assertTrue(isinstance(item, Miscellaneous))

    @mock.patch('inicie.cropimage.browser.miscellaneous.aq_inner')
    @mock.patch('inicie.cropimage.browser.miscellaneous.getUtility')
    def test_image_fields(self, getUtility, aq_inner):
        getUtility.return_value = {'inicie.cropimage.ids': []}
        context = mock.Mock()
        request = mock.Mock()
        item = self.createMiscellaneous(context, request)
        self.assertFalse(item.image_fields())
        getUtility.return_value = {'inicie.cropimage.ids': ['image']}
        aq_inner().keys.return_value = ['image']
        from plone.app.blob.subtypes.image import ExtensionBlobField
        aq_inner().getField.return_value = ExtensionBlobField()
        aq_inner().Schema().keys.return_value = ['image']
        self.assertEqual(item.image_fields(), ['image'])
        from Products.Archetypes.Field import ImageField
        aq_inner().getField.return_value = ImageField()
        aq_inner().Schema().keys.return_value = ['image']
        self.assertEqual(item.image_fields(), ['image'])

    def test_has_image(self):
        context = mock.Mock()
        request = mock.Mock()
        item = self.createMiscellaneous(context, request)
        item.image_fields = mock.Mock(return_value=None)
        self.assertFalse(item.has_image())
        item.image_fields = mock.Mock(return_value=['image'])
        self.assertTrue(item.has_image())
